<?php
namespace Geral\Repositories;

class Itemencargo extends \Doctrine\ORM\EntityRepository
{
    public function insertItemEncargosNotaFiscal($cdfilial, $nrlantonf, $nrorg, $dtatual){
        $sql  = <<<SQL
          BEGIN
              INSERT INTO ITEMENCARGO
                     (CDENCARGO, CDFILIAL, NRLANCTONF, VRITEMENCA, VRENMOEDESTR, NRORG,
                     DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU,
                     CDOPERULTATU)
              SELECT ENCARGO.CDENCARGO                          AS CDENCARGO     ,
                     NVL(ITEMENCARGO.CDFILIAL  , :P_CDFILIAL)   AS CDFILIAL      ,
                     NVL(ITEMENCARGO.NRLANCTONF, :P_NRLANCTONF) AS NRLANCTONF    ,
                     NVL(ITEMENCARGO.VRITEMENCA, 0)             AS VRITEMENCA    ,
                     ITEMENCARGO.VRENMOEDESTR                   AS VRENMOEDESTR  ,
                     NVL(ITEMENCARGO.NRORG     , :P_NRORG)      AS NRORG         ,
                     NVL(ITEMENCARGO.DTINCLUSAO, :P_DTATUAL)    AS DTINCLUSAO    ,
                     ITEMENCARGO.DTULTATU                       AS DTULTATU      ,
                     ITEMENCARGO.NRORGINCLUSAO                  AS NROGINCLUSAO  ,
                     ITEMENCARGO.CDOPERINCLUSAO                 AS CDOPERINCLUSAO,
                     ITEMENCARGO.NRORGULTATU                    AS NRORGULTATU   ,
                     ITEMENCARGO.CDOPERULTATU                   AS CDOPERULTATU
                FROM ENCARGO
                LEFT JOIN
             (SELECT ITEMENCARGO.CDENCARGO,
                     ITEMENCARGO.CDFILIAL,
                     ITEMENCARGO.NRLANCTONF,
                     ITEMENCARGO.VRITEMENCA,
                     ITEMENCARGO.VRENMOEDESTR,
                     ITEMENCARGO.NRORG,
                     ITEMENCARGO.DTINCLUSAO,
                     ITEMENCARGO.DTULTATU,
                     ITEMENCARGO.NRORGINCLUSAO,
                     ITEMENCARGO.CDOPERINCLUSAO,
                     ITEMENCARGO.NRORGULTATU,
                     ITEMENCARGO.CDOPERULTATU
                FROM ITEMENCARGO
               WHERE ITEMENCARGO.NRORG      = :P_NRORG         AND
                     ITEMENCARGO.CDFILIAL   = :P_CDFILIAL      AND
                     ITEMENCARGO.NRLANCTONF = :P_NRLANCTONF) ITEMENCARGO
                  ON ENCARGO.CDENCARGO = ITEMENCARGO.CDENCARGO AND
                     ENCARGO.NRORG = ITEMENCARGO.NRORG
            ORDER BY ITEMENCARGO.CDENCARGO;
            EXCEPTION
              WHEN OTHERS THEN NULL;
          END;
SQL;

        $params = array(
            "P_NRORG"      => $nrorg    ,
            "P_CDFILIAL"   => $cdfilial ,
            "P_NRLANCTONF" => $nrlantonf,
            "P_DTATUAL"    => $dtatual  ,
        );

        $this->getEntityManager()->getConnection()->executeQuery($sql, $params);

    }

    public function save($params) {
        $sql = "INSERT INTO ITEMENCARGO
                            (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
                     VALUES (?,?,?,?)";

        $connection = $this->getEntityManager()->getConnection();

        return $connection->executeUpdate($sql,$params);
    }
}